CoCoA-5 - Feature #346

Describe should indicate package name
29 Apr 2013 08:36 - John Abbott

Status: Closed Start date: 29 Apr 2013
Priority: Normal Due date:

Assignee: Anna Maria Bigatti % Done: 100%
Category: Parser/Interpreter Estimated time: 2.22 hours
Target version: CoCoA-5.4.0 Spent time: 2.20 hours
Description

The describe command will produce the source code of a package function, but it does not indicate the package the function comes
from. It should indicate the package (perhaps simply as a comment, so the source code produced remains fairly valid).

Try the following:

describe BinExp;

2021-01 Describe cannot know the package name (see #10), so added functions and suggestions when calling describe for a

user defined function

Related issues:

Related to CoCoA-5 - Support #208: describe $package Closed 11 Jul 2012

Related to CoCoA-5 - Feature #531: Package protected variables should know wh... Closed 09 Apr 2014
Related to CoCoA-5 - Feature #1174: package of a function --> of an identifier! Closed 05 Apr 2018
Related to CoCoA-5 - Design #1546: Improve 'describe’ or 'print' for a function Closed 04 Dec 2020
History

#1 - 18 Mar 2014 12:03 - John Abbott

The relevant source code appears to be in Interpreter.C:229:

void UserDefinedFunction: :describe (intrusive_ptr<OutputStreamValue> out) const...

#2 - 18 Mar 2014 12:14 - John Abbott

Packages export their varables in the function:

void PackageStatement::implExecute (RuntimeEnvironment *runtimeEnv)

in file Interpreter.C:3885

The relevant code appears to be in lines 3939-3948, though I'm not sure | understand it all.
#3 - 18 Mar 2014 15:48 - John Abbott

A possibly simpler solution to the problem would be to have a function PackageOf which says which package protected a package-protected
variable. The result would presumably be a string.

#4 - 02 Apr 2014 17:34 - Anna Maria Bigatti
- Target version set to CoCoA-5.1.0 Easter14

#5 - 04 Apr 2014 17:06 - John Abbott
- Target version changed from CoCoA-5.1.0 Easter14 to CoCoA-5.2.7

#6 - 05 Apr 2018 13:43 - John Abbott

- Related to Feature #1174: package of a function --> of an identifier! added

#7 - 13 Jun 2018 14:51 - John Abbott

The CoCoA fn Starting says when a symbol comes from a package, and which package it comes from, so describe should be able to do it too!
Investigate!

#8 - 11 Dec 2020 11:48 - Anna Maria Bigatti

- Related to Design #1546: Improve 'describe’ or ‘print' for a function added

#9 - 15 Jan 2021 09:13 - John Abbott

Since Anna seems to have solved issue #1174, is it now possible to make progress here?

Since normal printing now produces the source code of a CoCoA function, what should describe do when given a package-exported variable?
Does describe operate with the variable or on the value of the variable... or both?

#10 - 15 Jan 2021 20:52 - John Abbott
- Status changed from New to Resolved

- % Done changed from 0 to 60

IMPORTANT
e the describe command describes a value and not a variable;
¢ a fn defn does not contain any information about which package the defn was in;
¢ the package info is associated with the protected top-level variable created by an export command.

Given this situation it is impossible for describe know the package (since it evaluates its argument).

#11 - 15 Jan 2021 20:56 - John Abbott

Since print and sprint now produce the body of a CoCoA-5 function, it superfluous for describe to do the same.

SUGGESTION:

when describe applied to a function it can produce a succinct description similar to what print used to produce e.g. <built-in function> and
<user-defined function>

Note: if a fn "knows" whether it was defined in a package, it might be possible to have also <package-defined function>

JAA is hoping Anna will modify the impl of describe to behave as suggested here (we did agree on this during today's call).
#12 - 15 Jan 2021 20:56 - John Abbott
- Target version changed from CoCoA-5.?.7 to CoCoA-5.4.0

#13 - 22 Jan 2021 08:23 - Anna Maria Bigatti
- Description updated

- Status changed from Resolved to Feedback
- Assignee set to Anna Maria Bigatti

- % Done changed from 60 to 90

#14 - 19 Mar 2021 12:48 - John Abbott

- Description updated

- Status changed from Feedback to Closed
- % Done changed from 90 to 100

- Estimated time set to 2.22 h

As reported in comment 10, the original request cannot be fulfilled -- instead use new fn PackageOf, see issue #1174.
